Index: palm/trunk/SOURCE/pmc_interface_mod.f90
===================================================================
--- palm/trunk/SOURCE/pmc_interface_mod.f90	(revision 3876)
+++ palm/trunk/SOURCE/pmc_interface_mod.f90	(revision 3883)
@@ -25,4 +25,10 @@
 ! -----------------
 ! $Id$
+! Checks and error messages improved and extended. All the child index bounds in the
+! parent-grid index space are made module variables. Function get_number_of_childs
+! renamed get_number_of_children. A number of variables renamed 
+! and qite a lot of other code reshaping made all around the module. 
+! 
+! 3876 2019-04-08 18:41:49Z knoop
 ! Implemented nesting for salsa variables.
 ! 
@@ -485,18 +491,20 @@
     INTEGER(iwp), PARAMETER ::  child_to_parent = 2   !<
     INTEGER(iwp), PARAMETER ::  parent_to_child = 1   !<
-    INTEGER(iwp), PARAMETER ::  interpolation_scheme_lrsn  = 2  !< Interpolation scheme to be used on lateral boundaries (maybe to be made user parameter)
-    INTEGER(iwp), PARAMETER ::  interpolation_scheme_t     = 3  !< Interpolation scheme to be used on top boundary (maybe to be made user parameter)
+    INTEGER(iwp), PARAMETER ::  interpolation_scheme_lrsn  = 2  !< Interpolation scheme to be used on lateral boundaries
+    INTEGER(iwp), PARAMETER ::  interpolation_scheme_t     = 3  !< Interpolation scheme to be used on top boundary
 !
 !-- Coupler setup
     INTEGER(iwp), SAVE      ::  comm_world_nesting    !<
     INTEGER(iwp), SAVE      ::  cpl_id  = 1           !<
-    CHARACTER(LEN=32), SAVE ::  cpl_name              !<
     INTEGER(iwp), SAVE      ::  cpl_npe_total         !<
     INTEGER(iwp), SAVE      ::  cpl_parent_id         !<
+    
+    CHARACTER(LEN=32), SAVE ::  cpl_name              !<
+
 !
 !-- Control parameters
+    INTEGER(iwp),     SAVE ::  anterpolation_buffer_width = 2       !< Boundary buffer width for anterpolation
     CHARACTER(LEN=7), SAVE ::  nesting_datatransfer_mode = 'mixed'  !< steering parameter for data-transfer mode
     CHARACTER(LEN=8), SAVE ::  nesting_mode = 'two-way'             !< steering parameter for 1- or 2-way nesting
-    INTEGER(iwp),     SAVE ::  anterpolation_buffer_width = 2       !< Boundary buffer width for anterpolation
     
     LOGICAL, SAVE ::  nested_run = .FALSE.  !< general switch
@@ -511,6 +519,4 @@
 !-- Children's parent-grid arrays
     INTEGER(iwp), SAVE, DIMENSION(5), PUBLIC    ::  coarse_bound        !< subdomain index bounds for children's parent-grid arrays
-    INTEGER(iwp), SAVE, DIMENSION(4), PUBLIC    ::  coarse_bound_aux    !< subdomain index bounds for allocation of index-mapping and other auxiliary arrays
-    INTEGER(iwp), SAVE, DIMENSION(4), PUBLIC    ::  coarse_bound_w      !< subdomain index bounds for children's parent-grid work arrays
 
     REAL(wp), SAVE, DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  dissc !< Parent-grid array on child domain - dissipation rate
@@ -529,24 +535,36 @@
     INTEGER(idp), SAVE, DIMENSION(:,:), ALLOCATABLE, TARGET, PUBLIC ::  part_adrc   !<
 
-    REAL(wp), SAVE, DIMENSION(:,:,:,:), ALLOCATABLE, TARGET ::  chem_spec_c !< coarse grid array on child domain - chemical species
-
-    REAL(wp), SAVE, DIMENSION(:,:,:,:), ALLOCATABLE, TARGET ::  aerosol_mass_c   !< aerosol mass
-    REAL(wp), SAVE, DIMENSION(:,:,:,:), ALLOCATABLE, TARGET ::  aerosol_number_c !< aerosol number 
-    REAL(wp), SAVE, DIMENSION(:,:,:,:), ALLOCATABLE, TARGET ::  salsa_gas_c      !<  salsa gases
+    REAL(wp), SAVE, DIMENSION(:,:,:,:), ALLOCATABLE, TARGET ::  chem_spec_c  !< Parent-grid array on child domain - chemical species
+
+    REAL(wp), SAVE, DIMENSION(:,:,:,:), ALLOCATABLE, TARGET ::  aerosol_mass_c    !< Aerosol mass
+    REAL(wp), SAVE, DIMENSION(:,:,:,:), ALLOCATABLE, TARGET ::  aerosol_number_c  !< Aerosol number 
+    REAL(wp), SAVE, DIMENSION(:,:,:,:), ALLOCATABLE, TARGET ::  salsa_gas_c       !< SALSA gases
 !
 !-- Grid-spacing ratios.
-    INTEGER(iwp), SAVE ::  igsr     !< Integer grid-spacing ratio in i-direction 
-    INTEGER(iwp), SAVE ::  jgsr     !< Integer grid-spacing ratio in j-direction 
-    INTEGER(iwp), SAVE ::  kgsr     !< Integer grid-spacing ratio in k-direction
+    INTEGER(iwp), SAVE ::  igsr    !< Integer grid-spacing ratio in i-direction 
+    INTEGER(iwp), SAVE ::  jgsr    !< Integer grid-spacing ratio in j-direction 
+    INTEGER(iwp), SAVE ::  kgsr    !< Integer grid-spacing ratio in k-direction
 !
 !-- Global parent-grid index bounds
-    INTEGER(iwp), SAVE ::  iplg     !< Leftmost parent-grid array ip index of the whole child domain
-    INTEGER(iwp), SAVE ::  iprg     !< Rightmost parent-grid array ip index of the whole child domain
-    INTEGER(iwp), SAVE ::  jpsg     !< Southmost parent-grid array jp index of the whole child domain
-    INTEGER(iwp), SAVE ::  jpng     !< Northmost parent-grid array jp index of the whole child domain
-!
-!-- Local parent-grid index bounds (to be moved here from pmci_setup_child)
-!-- EXPLAIN WHY SEVERAL SETS OF PARENT-GRID INDEX BOUNDS ARE NEEDED.
-    
+    INTEGER(iwp), SAVE ::  iplg    !< Leftmost parent-grid array ip index of the whole child domain
+    INTEGER(iwp), SAVE ::  iprg    !< Rightmost parent-grid array ip index of the whole child domain
+    INTEGER(iwp), SAVE ::  jpsg    !< Southmost parent-grid array jp index of the whole child domain
+    INTEGER(iwp), SAVE ::  jpng    !< Northmost parent-grid array jp index of the whole child domain
+!
+!-- Local parent-grid index bounds. Different sets of index bounds are needed for parent-grid arrays (uc, etc),
+!-- for index mapping arrays (iflu, etc) and for work arrays (workarr_lr, etc). This is because these arrays
+!-- have different dimensions depending on the location of the subdomain relative to boundaries and corners.
+    INTEGER(iwp), SAVE ::  ipl     !< Left index limit for children's parent-grid arrays
+    INTEGER(iwp), SAVE ::  ipla    !< Left index limit for allocation of index-mapping and other auxiliary arrays
+    INTEGER(iwp), SAVE ::  iplw    !< Left index limit for children's parent-grid work arrays
+    INTEGER(iwp), SAVE ::  ipr     !< Right index limit for children's parent-grid arrays
+    INTEGER(iwp), SAVE ::  ipra    !< Right index limit for allocation of index-mapping and other auxiliary arrays
+    INTEGER(iwp), SAVE ::  iprw    !< Right index limit for children's parent-grid work arrays
+    INTEGER(iwp), SAVE ::  jpn     !< North index limit for children's parent-grid arrays
+    INTEGER(iwp), SAVE ::  jpna    !< North index limit for allocation of index-mapping and other auxiliary arrays
+    INTEGER(iwp), SAVE ::  jpnw    !< North index limit for children's parent-grid work arrays
+    INTEGER(iwp), SAVE ::  jps     !< South index limit for children's parent-grid arrays
+    INTEGER(iwp), SAVE ::  jpsa    !< South index limit for allocation of index-mapping and other auxiliary arrays
+    INTEGER(iwp), SAVE ::  jpsw    !< South index limit for children's parent-grid work arrays
 !
 !-- Highest prognostic parent-grid k-indices.
@@ -568,21 +586,26 @@
     INTEGER(iwp), SAVE, ALLOCATABLE, DIMENSION(:) ::  kfuo   !< child index indicating upper bound of parent grid box on scalar-grid
 !
-!-- Number of fine-grid nodes inside coarse-grid ij-faces
-!-- to be precomputed for anterpolation.
-    INTEGER(iwp), SAVE, ALLOCATABLE, DIMENSION(:,:,:) ::  ijkfc_u  !< number of child grid boxes contribution to a parent grid box, u-grid
-    INTEGER(iwp), SAVE, ALLOCATABLE, DIMENSION(:,:,:) ::  ijkfc_v  !< number of child grid boxes contribution to a parent grid box, v-grid
-    INTEGER(iwp), SAVE, ALLOCATABLE, DIMENSION(:,:,:) ::  ijkfc_w  !< number of child grid boxes contribution to a parent grid box, w-grid
-    INTEGER(iwp), SAVE, ALLOCATABLE, DIMENSION(:,:,:) ::  ijkfc_s  !< number of child grid boxes contribution to a parent grid box, scalar-grid
+!-- Number of child-grid nodes within anterpolation cells to be precomputed for anterpolation.
+    INTEGER(iwp), SAVE, ALLOCATABLE, DIMENSION(:,:,:) ::  ijkfc_u  !< number of child grid points contributing to a parent grid
+                                                                   !< node in anterpolation, u-grid
+    INTEGER(iwp), SAVE, ALLOCATABLE, DIMENSION(:,:,:) ::  ijkfc_v  !< number of child grid points contributing to a parent grid
+                                                                   !< node in anterpolation, v-grid
+    INTEGER(iwp), SAVE, ALLOCATABLE, DIMENSION(:,:,:) ::  ijkfc_w  !< number of child grid points contributing to a parent grid
+                                                                   !< node in anterpolation, w-grid
+    INTEGER(iwp), SAVE, ALLOCATABLE, DIMENSION(:,:,:) ::  ijkfc_s  !< number of child grid points contributing to a parent grid
+                                                                   !< node in anterpolation, scalar-grid
 !    
 !-- Work arrays for interpolation and user-defined type definitions for horizontal work-array exchange    
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE :: workarrc_lr
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE :: workarrc_sn
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE :: workarrc_t
-    INTEGER(iwp) :: workarrc_lr_exchange_type
-    INTEGER(iwp) :: workarrc_sn_exchange_type
-    INTEGER(iwp) :: workarrc_t_exchange_type_x
-    INTEGER(iwp) :: workarrc_t_exchange_type_y
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE :: workarr_lr
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE :: workarr_sn
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE :: workarr_t
+
+    INTEGER(iwp) :: workarr_lr_exchange_type
+    INTEGER(iwp) :: workarr_sn_exchange_type
+    INTEGER(iwp) :: workarr_t_exchange_type_x
+    INTEGER(iwp) :: workarr_t_exchange_type_y
  
     INTEGER(iwp), DIMENSION(3)          ::  parent_grid_info_int    !<
+
     REAL(wp), DIMENSION(7)              ::  parent_grid_info_real   !<
     REAL(wp), DIMENSION(2)              ::  zmax_coarse             !<
@@ -607,5 +630,5 @@
     END TYPE parentgrid_def
 
-    TYPE(parentgrid_def), SAVE, PUBLIC     ::  cg                 !< change to pg
+    TYPE(parentgrid_def), SAVE, PUBLIC     ::  pg                 !< Parent-grid information package of type parentgrid_def
 !
 !-- Variables for particle coupling
@@ -617,5 +640,5 @@
        REAL(wp)                            ::  dy                   !<
        REAL(wp)                            ::  dz                   !<
-       REAL(wp)                            ::  lx_coord, lx_coord_b !<
+       REAL(wp)                            ::  lx_coord, lx_coord_b !<   ! split onto separate lines
        REAL(wp)                            ::  rx_coord, rx_coord_b !<
        REAL(wp)                            ::  sy_coord, sy_coord_b !<
@@ -624,8 +647,8 @@
     END TYPE childgrid_def
 
-    TYPE(childgrid_def), SAVE, ALLOCATABLE, DIMENSION(:), PUBLIC :: childgrid !<
-
-    INTEGER(idp),ALLOCATABLE,DIMENSION(:,:),PUBLIC,TARGET    :: nr_part  !<
-    INTEGER(idp),ALLOCATABLE,DIMENSION(:,:),PUBLIC,TARGET    :: part_adr !<
+    TYPE(childgrid_def), SAVE, ALLOCATABLE, DIMENSION(:), PUBLIC ::  childgrid  !<
+
+    INTEGER(idp), ALLOCATABLE,DIMENSION(:,:), PUBLIC,TARGET ::  nr_part  !<
+    INTEGER(idp), ALLOCATABLE,DIMENSION(:,:), PUBLIC,TARGET ::  part_adr !<
 
    
@@ -662,7 +685,7 @@
     END INTERFACE
 
-    INTERFACE get_number_of_childs
-       MODULE PROCEDURE get_number_of_childs
-    END  INTERFACE get_number_of_childs
+    INTERFACE get_number_of_children
+       MODULE PROCEDURE get_number_of_children
+    END  INTERFACE get_number_of_children
 
     INTERFACE get_childid
@@ -693,5 +716,5 @@
     PUBLIC pmci_synchronize
     PUBLIC pmci_set_swaplevel
-    PUBLIC get_number_of_childs, get_childid, get_child_edges, get_child_gridspacing
+    PUBLIC get_number_of_children, get_childid, get_child_edges, get_child_gridspacing
 
 
@@ -792,4 +815,5 @@
     INTEGER(iwp) ::  ncpl   !<  number of nest domains
 
+    
 #if defined( __parallel )
     CALL location_message( 'setup the nested model configuration', .FALSE. )
@@ -797,18 +821,19 @@
 !
 !-- Compute absolute coordinates for all models
-    CALL pmci_setup_coordinates
+    CALL pmci_setup_coordinates         ! CONTAIN THIS 
 !
 !-- Determine the number of coupled arrays
-    CALL pmci_num_arrays
+    CALL pmci_num_arrays                ! CONTAIN THIS
 !
 !-- Initialize the child (must be called before pmc_setup_parent)
-    CALL pmci_setup_child
+!  EXTEND THIS COMMENT EXPLAINEIN WHY IT MUST BE CALLED BEFORE    
+    CALL pmci_setup_child               ! CONTAIN THIS
 !
 !-- Initialize PMC parent
-    CALL pmci_setup_parent
+    CALL pmci_setup_parent              ! CONTAIN THIS
 !
 !-- Check for mismatches between settings of master and child variables
 !-- (e.g., all children have to follow the end_time settings of the root master)
-    CALL pmci_check_setting_mismatches
+    CALL pmci_check_setting_mismatches  ! CONTAIN THIS
 !
 !-- Set flag file for combine_plot_fields for precessing the nest output data
@@ -831,51 +856,77 @@
     IMPLICIT NONE
 
-    CHARACTER(LEN=32) ::  myname
-    INTEGER(iwp) ::  child_id         !<
-    INTEGER(iwp) ::  ib = 1           !< running index for aerosol size bins
-    INTEGER(iwp) ::  ic = 1           !< running index for aerosol mass bins
-    INTEGER(iwp) ::  ig = 1           !< running index for salsa gases
-    INTEGER(iwp) ::  ierr             !<
-    INTEGER(iwp) ::  k                !<
-    INTEGER(iwp) ::  m                !<
-    INTEGER(iwp) ::  mid              !<
-    INTEGER(iwp) ::  mm               !<
-    INTEGER(iwp) ::  n = 1            !< running index for chemical species
-    INTEGER(iwp) ::  nest_overlap     !<
-    INTEGER(iwp) ::  nomatch          !<
-    INTEGER(iwp) ::  nx_cl            !<
-    INTEGER(iwp) ::  ny_cl            !<
-    INTEGER(iwp) ::  nz_cl            !<
-
-    INTEGER(iwp), DIMENSION(5) ::  val    !<
-
-    REAL(wp), DIMENSION(:), ALLOCATABLE ::  ch_xl   !<
-    REAL(wp), DIMENSION(:), ALLOCATABLE ::  ch_xr   !<    
-    REAL(wp), DIMENSION(:), ALLOCATABLE ::  ch_ys   !<
-    REAL(wp), DIMENSION(:), ALLOCATABLE ::  ch_yn   !<
-    REAL(wp) ::  cl_height        !< 
-    REAL(wp) ::  dx_cl            !<
-    REAL(wp) ::  dy_cl            !<
-    REAL(wp) ::  dz_cl            !<
-    REAL(wp) ::  left_limit       !<
-    REAL(wp) ::  north_limit      !<
-    REAL(wp) ::  right_limit      !<
-    REAL(wp) ::  south_limit      !<
-    REAL(wp) ::  xez              !<
-    REAL(wp) ::  yez              !<
-    REAL(wp), DIMENSION(5) ::  fval                      !< Array for receiving the child-grid spacings etc 
-    REAL(wp), DIMENSION(:), ALLOCATABLE ::  cl_coord_x   !<
-    REAL(wp), DIMENSION(:), ALLOCATABLE ::  cl_coord_y   !<
-
-!
-!   Initialize the pmc parent
+    INTEGER(iwp) ::  child_id           !< Child id-number for the child m
+    INTEGER(iwp) ::  ierr               !< MPI-error code 
+    INTEGER(iwp) ::  kp                 !< Parent-grid index n the z-direction
+    INTEGER(iwp) ::  lb = 1             !< Running index for aerosol size bins
+    INTEGER(iwp) ::  lc = 1             !< Running index for aerosol mass bins
+    INTEGER(iwp) ::  lg = 1             !< Running index for SALSA gases
+    INTEGER(iwp) ::  m                  !< Loop index over all children of the current parent
+    INTEGER(iwp) ::  msib               !< Loop index over all other children than m in case of siblings (parallel children)
+    INTEGER(iwp) ::  n = 1              !< Running index for chemical species
+    INTEGER(iwp) ::  nest_overlap = 0   !< Tag for parallel child-domains' overlap situation (>0 if overlap found)
+    INTEGER(iwp) ::  nomatch = 0        !< Tag for child-domain mismatch situation (>0 if mismatch found)
+    INTEGER(iwp) ::  nx_child           !< Number of child-grid points in the x-direction
+    INTEGER(iwp) ::  ny_child           !< Number of child-grid points in the y-direction
+    INTEGER(iwp) ::  nz_child           !< Number of child-grid points in the z-direction
+    
+    INTEGER(iwp), DIMENSION(3) ::  child_grid_dim  !< Array for receiving the child-grid dimensions from the children
+    
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  child_x_left   !< Minimum x-coordinate of the child domain including the ghost
+                                                           !< point layers 
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  child_x_right  !< Maximum x-coordinate of the child domain including the ghost
+                                                           !< point layers   
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  child_y_south  !< Minimum y-coordinate of the child domain including the ghost
+                                                           !< point layers
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  child_y_north  !< Maximum y-coordinate of the child domain including the ghost
+                                                           !< point layers
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  child_coord_x  !< Child domain x-coordinate array
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  child_coord_y  !< Child domain y-coordinate array
+    
+    REAL(wp), DIMENSION(5) ::  child_grid_info  !< Array for receiving the child-grid spacings etc from the children
+    
+    REAL(wp) ::  child_height         !< Height of the child domain defined on the child side as zw(nzt+1)
+    REAL(wp) ::  dx_child             !< Child-grid spacing in the x-direction
+    REAL(wp) ::  dy_child             !< Child-grid spacing in the y-direction
+    REAL(wp) ::  dz_child             !< Child-grid spacing in the z-direction
+    REAL(wp) ::  left_limit           !< Left limit for the absolute x-coordinate of the child left boundary 
+    REAL(wp) ::  north_limit          !< North limit for the absolute y-coordinate of the child north boundary
+    REAL(wp) ::  right_limit          !< Right limit for the absolute x-coordinate of the child right boundary
+    REAL(wp) ::  south_limit          !< South limit for the absolute y-coordinate of the child south boundary 
+    REAL(wp) ::  upper_right_coord_x  !< Absolute x-coordinate of the upper right corner of the child domain 
+    REAL(wp) ::  upper_right_coord_y  !< Absolute y-coordinate of the upper right corner of the child domain  
+    REAL(wp) ::  xez                  !< Minimum separation in the x-direction required between the child and
+                                      !< parent boundaries (left or right)
+    REAL(wp) ::  yez                  !< Minimum separation in the y-direction required between the child and
+                                      !< parent boundaries (south or north)
+    CHARACTER(LEN=32) ::  myname      !< String for variable name such as 'u'
+
+    LOGICAL :: m_left_in_msib         !< Logical auxiliary parameter for the overlap test: true if the left border
+                                      !< of the child m is within the x-range of the child msib
+    LOGICAL :: m_right_in_msib        !< Logical auxiliary parameter for the overlap test: true if the right border
+                                      !< of the child m is within the x-range of the child msib 
+    LOGICAL :: msib_left_in_m         !< Logical auxiliary parameter for the overlap test: true if the left border
+                                      !< of the child msib is within the x-range of the child m
+    LOGICAL :: msib_right_in_m        !< Logical auxiliary parameter for the overlap test: true if the right border
+                                      !< of the child msib is within the x-range of the child m
+    LOGICAL :: m_south_in_msib        !< Logical auxiliary parameter for the overlap test: true if the south border
+                                      !< of the child m is within the y-range of the child msib
+    LOGICAL :: m_north_in_msib        !< Logical auxiliary parameter for the overlap test: true if the north border
+                                      !< of the child m is within the y-range of the child msib 
+    LOGICAL :: msib_south_in_m        !< Logical auxiliary parameter for the overlap test: true if the south border
+                                      !< of the child msib is within the y-range of the child m
+    LOGICAL :: msib_north_in_m        !< Logical auxiliary parameter for the overlap test: true if the north border
+                                      !< of the child msib is within the y-range of the child m
+!
+!-- Initialize the current pmc parent
     CALL pmc_parentinit
 !
-!-- Corners of all children of the present parent
-    IF ( ( SIZE( pmc_parent_for_child ) - 1 > 0 ) .AND. myid == 0 )  THEN 
-       ALLOCATE( ch_xl(1:SIZE( pmc_parent_for_child ) - 1) )
-       ALLOCATE( ch_xr(1:SIZE( pmc_parent_for_child ) - 1) )
-       ALLOCATE( ch_ys(1:SIZE( pmc_parent_for_child ) - 1) )
-       ALLOCATE( ch_yn(1:SIZE( pmc_parent_for_child ) - 1) )
+!-- Corners of all children of the present parent. Note that 
+!-- SIZE( pmc_parent_for_child ) = 1 if we have no children.
+    IF ( ( SIZE( pmc_parent_for_child ) - 1 > 0 )  .AND.  myid == 0 )  THEN 
+       ALLOCATE( child_x_left(1:SIZE( pmc_parent_for_child ) - 1) )
+       ALLOCATE( child_x_right(1:SIZE( pmc_parent_for_child ) - 1) )
+       ALLOCATE( child_y_south(1:SIZE( pmc_parent_for_child ) - 1) )
+       ALLOCATE( child_y_north(1:SIZE( pmc_parent_for_child ) - 1) )
     ENDIF
     IF ( ( SIZE( pmc_parent_for_child ) - 1 > 0 ) )  THEN
@@ -883,5 +934,7 @@
     ENDIF
 !
-!-- Get coordinates from all children
+!-- Get coordinates from all children and check that the children match the parent
+!-- domain and each others. Note that SIZE( pmc_parent_for_child ) = 1 
+!-- if we have no children, thence the loop is not executed at all. 
     DO  m = 1, SIZE( pmc_parent_for_child ) - 1
 
@@ -890,35 +943,30 @@
        IF ( myid == 0 )  THEN
 
-          CALL pmc_recv_from_child( child_id, val,  SIZE(val),  0, 123, ierr )
-          CALL pmc_recv_from_child( child_id, fval, SIZE(fval), 0, 124, ierr )
+          CALL pmc_recv_from_child( child_id, child_grid_dim,  SIZE(child_grid_dim), 0, 123, ierr )
+          CALL pmc_recv_from_child( child_id, child_grid_info, SIZE(child_grid_info), 0, 124, ierr )
          
-          nx_cl     = val(1)
-          ny_cl     = val(2)
-          dx_cl     = fval(3)
-          dy_cl     = fval(4)
-          dz_cl     = fval(5)
-          cl_height = fval(1)
-
-          nz_cl = nz
-!
-!--       Find the highest nest level in the parent grid for the reduced z
+          nx_child     = child_grid_dim(1)
+          ny_child     = child_grid_dim(2)
+          dx_child     = child_grid_info(3)
+          dy_child     = child_grid_info(4)
+          dz_child     = child_grid_info(5)
+          child_height = child_grid_info(1)
+!
+!--       Find the highest child-domain level in the parent grid for the reduced z
 !--       transfer
-          DO  k = 1, nz                 
-             IF ( zw(k) > fval(1) )  THEN
-                nz_cl = k
+          DO  kp = 1, nz                 
+             IF ( zw(kp) > child_height )  THEN
+                nz_child = kp
                 EXIT
              ENDIF
           ENDDO
-          zmax_coarse = fval(1:2)
-          cl_height   = fval(1)
+          zmax_coarse  = child_grid_info(1:2)
 !    
 !--       Get absolute coordinates from the child
-          ALLOCATE( cl_coord_x(-nbgp:nx_cl+nbgp) )
-          ALLOCATE( cl_coord_y(-nbgp:ny_cl+nbgp) )
+          ALLOCATE( child_coord_x(-nbgp:nx_child+nbgp) )
+          ALLOCATE( child_coord_y(-nbgp:ny_child+nbgp) )
          
-          CALL pmc_recv_from_child( child_id, cl_coord_x, SIZE( cl_coord_x ),  &
-               0, 11, ierr )
-          CALL pmc_recv_from_child( child_id, cl_coord_y, SIZE( cl_coord_y ),  &
-               0, 12, ierr )
+          CALL pmc_recv_from_child( child_id, child_coord_x, SIZE( child_coord_x ), 0, 11, ierr )
+          CALL pmc_recv_from_child( child_id, child_coord_y, SIZE( child_coord_y ), 0, 12, ierr )
          
           parent_grid_info_real(1) = lower_left_coord_x
@@ -926,34 +974,39 @@
           parent_grid_info_real(3) = dx
           parent_grid_info_real(4) = dy
-          parent_grid_info_real(5) = lower_left_coord_x + ( nx + 1 ) * dx
-          parent_grid_info_real(6) = lower_left_coord_y + ( ny + 1 ) * dy
+
+          upper_right_coord_x      = lower_left_coord_x + ( nx + 1 ) * dx
+          upper_right_coord_y      = lower_left_coord_y + ( ny + 1 ) * dy
+          parent_grid_info_real(5) = upper_right_coord_x
+          parent_grid_info_real(6) = upper_right_coord_y
           parent_grid_info_real(7) = dz(1)
 
           parent_grid_info_int(1)  = nx
           parent_grid_info_int(2)  = ny
-          parent_grid_info_int(3)  = nz_cl
-!
-!--       Check that the child domain matches parent domain. 
-          nomatch = 0
+          parent_grid_info_int(3)  = nz_child
+!
+!--       Check that the child domain matches its parent domain. 
           IF ( nesting_mode == 'vertical' )  THEN
-             right_limit = parent_grid_info_real(5)
-             north_limit = parent_grid_info_real(6)
-             IF ( ( cl_coord_x(nx_cl+1) /= right_limit ) .OR.                  &
-                  ( cl_coord_y(ny_cl+1) /= north_limit ) )  THEN
+!
+!--          In case of vertical nesting, the lateral boundaries must match exactly. 
+             right_limit = upper_right_coord_x
+             north_limit = upper_right_coord_y
+             IF ( ( child_coord_x(nx_child+1) /= right_limit ) .OR.                                 &
+                  ( child_coord_y(ny_child+1) /= north_limit ) )  THEN
                 nomatch = 1
              ENDIF
           ELSE       
 !
-!--       Check that the child domain is completely inside the parent domain. 
+!--          In case of 3-D nesting, check that the child domain is completely 
+!--          inside its parent domain. 
              xez = ( nbgp + 1 ) * dx 
              yez = ( nbgp + 1 ) * dy 
              left_limit  = lower_left_coord_x + xez
-             right_limit = parent_grid_info_real(5) - xez
+             right_limit = upper_right_coord_x - xez
              south_limit = lower_left_coord_y + yez
-             north_limit = parent_grid_info_real(6) - yez
-             IF ( ( cl_coord_x(0) < left_limit )        .OR.                   &
-                  ( cl_coord_x(nx_cl+1) > right_limit ) .OR.                   &
-                  ( cl_coord_y(0) < south_limit )       .OR.                   &
-                  ( cl_coord_y(ny_cl+1) > north_limit ) )  THEN
+             north_limit = upper_right_coord_y - yez
+             IF ( ( child_coord_x(0) < left_limit )  .OR.                                           &
+                  ( child_coord_x(nx_child+1) > right_limit )  .OR.                                 &
+                  ( child_coord_y(0) < south_limit )  .OR.                                          &
+                  ( child_coord_y(ny_child+1) > north_limit ) )  THEN
                 nomatch = 1
              ENDIF
@@ -963,37 +1016,55 @@
 !--       that the top ghost layer of the child grid does not exceed 
 !--       the parent domain top boundary.
-          IF ( cl_height > zw(nz) ) THEN
+          IF ( child_height > zw(nz) ) THEN
              nomatch = 1
           ENDIF
 !
-!--       Check that parallel nest domains, if any, do not overlap.
-          nest_overlap = 0
-          IF ( SIZE( pmc_parent_for_child ) - 1 > 0 )  THEN
-             ch_xl(m) = cl_coord_x(-nbgp)
-             ch_xr(m) = cl_coord_x(nx_cl+nbgp)
-             ch_ys(m) = cl_coord_y(-nbgp)
-             ch_yn(m) = cl_coord_y(ny_cl+nbgp)
-
-             IF ( m > 1 )  THEN
-                DO mm = 1, m - 1
-                   mid = pmc_parent_for_child(mm)
-!
-!--                Check only different nest levels
-                   IF (m_couplers(child_id)%parent_id /= m_couplers(mid)%parent_id)  THEN
-                      IF ( ( ch_xl(m) < ch_xr(mm) .OR.                         &
-                             ch_xr(m) > ch_xl(mm) )  .AND.                     &
-                           ( ch_ys(m) < ch_yn(mm) .OR.                         &
-                             ch_yn(m) > ch_ys(mm) ) )  THEN
-                         nest_overlap = 1
-                      ENDIF
-                   ENDIF
-                ENDDO
-             ENDIF
-          ENDIF
+!--       If parallel child domains (siblings) do exist ( m > 1 ), 
+!--       check that they do not overlap.
+          child_x_left(m)  = child_coord_x(-nbgp)
+          child_x_right(m) = child_coord_x(nx_child+nbgp)
+          child_y_south(m) = child_coord_y(-nbgp)
+          child_y_north(m) = child_coord_y(ny_child+nbgp)
+
+          IF ( nesting_mode /= 'vertical' )  THEN
+!
+!--          Note that the msib-loop is executed only if ( m > 1 ).  
+!--          Also note that the tests have to be made both ways (m vs msib and msib vs m)
+!--          in order to detect all the possible overlap situations.
+             DO  msib = 1, m - 1
+!
+!--             Set some logical auxiliary parameters to simplify the IF-condition.  
+                m_left_in_msib  = ( child_x_left(m)  >= child_x_left(msib) )  .AND.                 &
+                                  ( child_x_left(m)  <= child_x_right(msib) )
+                m_right_in_msib = ( child_x_right(m) >= child_x_left(msib) )  .AND.                 &
+                                  ( child_x_right(m) <= child_x_right(msib) )
+                msib_left_in_m  = ( child_x_left(msib)  >= child_x_left(m) )  .AND.                 &
+                                  ( child_x_left(msib)  <= child_x_right(m) )
+                msib_right_in_m = ( child_x_right(msib) >= child_x_left(m) )  .AND.                 &
+                                  ( child_x_right(msib) <= child_x_right(m) )
+                m_south_in_msib = ( child_y_south(m) >= child_y_south(msib) )  .AND.                &
+                                  ( child_y_south(m) <= child_y_north(msib) )
+                m_north_in_msib = ( child_y_north(m) >= child_y_south(msib) )  .AND.                &
+                                  ( child_y_north(m) <= child_y_north(msib) )
+                msib_south_in_m = ( child_y_south(msib) >= child_y_south(m) )  .AND.                &
+                                  ( child_y_south(msib) <= child_y_north(m) )
+                msib_north_in_m = ( child_y_north(msib) >= child_y_south(m) )  .AND.                &
+                                  ( child_y_north(msib) <= child_y_north(m) )
+                
+                IF ( ( m_left_in_msib  .OR.  m_right_in_msib  .OR.                                  &
+                       msib_left_in_m  .OR.  msib_right_in_m )                                      &
+                     .AND.                                                                          &
+                     ( m_south_in_msib  .OR.  m_north_in_msib  .OR.                                 &
+                       msib_south_in_m  .OR.  msib_north_in_m ) )  THEN
+                     nest_overlap = 1
+                ENDIF
+
+             ENDDO
+          ENDIF          
 
           CALL set_child_edge_coords
 
-          DEALLOCATE( cl_coord_x )
-          DEALLOCATE( cl_coord_y )
+          DEALLOCATE( child_coord_x )
+          DEALLOCATE( child_coord_y )
 !
 !--       Send information about operating mode (LES or RANS) to child. This will be 
